# Conductor Setup

**Conductor Setup** is composed by a Docker image script that should be used to build the `autodynomite` image, and 3 different Docker Compose Swarm YAML files to deploy the Conductor in HA.

## Structure of the project

The AutoDynomite Docker image script file is present in `dynomite` folder.
The Docker Compose Swarm files are present in the `stack` folder.

## Built With

* [Docker](https://www.docker.com)

## Documentation

The provided Docker stack files provide the following configuration:

- 4 Dynomites nodes (2 shards with 1 replication each one, handled by Dynomite directly) based on `autodynomite` image that is backed by Redis DB in the same container
- 2 Conductor Server nodes with 2 replicas handled by Swarm
- 2 Conductor UI nodes with 2 replicas handled by Swarm
- 1 Elasticsearch node

Build the Docker `autodynomite` image with the `Dockerfile` present in the dynomite folder and launch the three Docker Compose Swarm files is sequence:

- dynomite-swarm.yaml
- elasticsearch-swarm.yaml
- conductor-swarm.yaml

The command to be executed should looks like: `docker stack deploy -c dynomite-swarm.yaml -c elasticsearch-swarm.yaml -c conductor-swarm.yaml [your stack name]`

If you plan to deploy **more than 4 nodes** for dynomite persistence you should modify the `dynomite-swarm.yaml` and the `seeds.list` files as per your needs.
The `conductor-swarm-config.properties` should be left unmodified.

## Change log

See [CHANGELOG.md](CHANGELOG.md).

## Authors

* **Marco Lettere** ([Nubisware S.r.l.](http://www.nubisware.com))
* **Mauro Mugnaini** ([Nubisware S.r.l.](http://www.nubisware.com))

## How to Cite this Software
[Intentionally left blank]

## License

This project is licensed under the EUPL V.1.1 License - see the [LICENSE.md](LICENSE.md) file for details.

## About the gCube Framework
This software is part of the [gCubeFramework](https://www.gcube-system.org/ "gCubeFramework"): an
open-source software toolkit used for building and operating Hybrid Data
Infrastructures enabling the dynamic deployment of Virtual Research Environments
by favouring the realisation of reuse oriented policies.
 
The projects leading to this software have received funding from a series of European Union programmes see [FUNDING.md](FUNDING.md)

## Acknowledgments
[Intentionally left blank]
